# Generated by Django 3.0.3 on 2021-05-13 23:12

from django.db import migrations


class Migration(migrations.Migration):

    dependencies = [
        ('relatorios', '0005_auto_20210331_1250'),
    ]

    operations = [
        # 2. TotaisTipoComunidade
        migrations.RunSQL(
            """
            DROP VIEW IF EXISTS relatorios_totaistipocomunidade;
            CREATE OR REPLACE VIEW relatorios_totaistipocomunidade AS
            SELECT mt.id       AS id,
                   mt.nome,
                   count(t.id) AS qtd_territorios,
                   sum(t.qtde_familias) as qtd_familias
            FROM main_territorio t
                     JOIN main_territorio_tipos_comunidade mttc ON t.id = mttc.territorio_id
                     JOIN main_tipocomunidade mt ON mttc.tipocomunidade_id = mt.id
            WHERE t.deleted IS NULL AND t.status_id = 4
            GROUP BY mt.id, mt.nome
            ORDER BY qtd_territorios DESC, mt.id;
            """),

        # 3. TotaisAreasDeUso
        migrations.RunSQL(
            """
            DROP VIEW IF EXISTS relatorios_totaisareasdeuso;
            CREATE OR REPLACE VIEW relatorios_totaisareasdeuso AS
            SELECT mt.id,
                   mt.nome,
                   count(au.id) AS qtd_areasdeuso
            FROM main_areadeuso au
                     JOIN main_tipoareadeuso mt ON au.tipo_area_de_uso_id = mt.id
                     JOIN main_territorio t ON au.territorio_id = t.id AND t.status_id = 4
            WHERE au.deleted IS NULL
            GROUP BY mt.id, mt.nome
            ORDER BY qtd_areasdeuso DESC, mt.id;
            """),

        # 4. TotaisConflitos
        migrations.RunSQL(
            """
            DROP VIEW IF EXISTS relatorios_totaisconflitos;
            CREATE OR REPLACE VIEW relatorios_totaisconflitos AS
            SELECT tc.id,
                   tc.nome,
                   count(cf.id) AS qtd_conflitos
            FROM main_conflito cf
                     JOIN main_tipoconflito tc ON cf.tipo_conflito_id = tc.id
                     JOIN main_territorio t ON cf.territorio_id = t.id AND t.status_id = 4
            WHERE cf.deleted IS NULL
            GROUP BY tc.id, tc.nome
            ORDER BY qtd_conflitos DESC, tc.id;
            """),

        # 6. Totais - EstadosTerritorios
        migrations.RunSQL(
            """
            DROP VIEW IF EXISTS relatorios_estadosterritorios;
            CREATE OR REPLACE VIEW relatorios_estadosterritorios AS
            SELECT me.id          AS id,
                   lower(me.uf)   AS uf,
                   me.nome        AS nome,
                   count(terr.id) AS qtd_territorios
            FROM main_territorio terr
                     JOIN main_municipio mm ON terr.municipio_referencia_id = mm.id
                     JOIN main_estado me ON mm.estado_id = me.id
            WHERE terr.deleted IS NULL AND terr.status_id = 4
            GROUP BY me.id, me.uf, me.nome
            ORDER BY qtd_territorios DESC, me.nome
            """),
    ]
